## scrappie 1.4.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
project (scrappie C)

option (BUILD_SHARED_LIB "Build a shared library" OFF)

set(CMAKE_CONFIGURATION_TYPES "Debug;Chaos;Release")
if(NOT CMAKE_BUILD_TYPE)
	message("Defaulting to release build")
	set(CMAKE_BUILD_TYPE Release)
endif()

include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Scrappie is the technology demonstration platform for the Research algorithms' group.")
set (CPACK_PACKAGE_VENDOR "Oxford Nanopore Technologies")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE.md")
set (CPACK_PACKAGE_VERSION_MAJOR 1)
set (CPACK_PACKAGE_VERSION_MINOR 4)
set (CPACK_PACKAGE_VERSION_PATCH 0)

# Get the latest abbreviated commit hash of the working branch
execute_process(
	COMMAND git log -1 --format=%h
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	OUTPUT_VARIABLE GIT_COMMIT_HASH
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

set (CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}-${GIT_COMMIT_HASH}")
set (CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")
set (CPACK_PACKAGE_NAME "ont-${PROJECT_NAME}")

set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Tim Massingham <tim.massingham@nanoporetech.com>")
set (CPACK_DEBIAN_PACKAGE_SECTION "base")
set (CPACK_DEBIAN_PACKAGE_DEPENDS "libopenblas-base, libhdf5-7, libcunit1")
set (CPACK_DEBIAN_BUILD_DEPENDS "libopenblas-base, libopenblas-dev, libhdf5-7, libhdf5-dev, cmake, libcunit1-dev")
set (CPACK_PACKAGING_INSTALL_PREFIX "/opt/scrappie")

set (CPACK_GENERATOR "TGZ;DEB")
include (CPack)


configure_file (
    "${PROJECT_SOURCE_DIR}/src/version.h.in"
    "${PROJECT_BINARY_DIR}/include/version.h"
)


##
#   Set up include directories
##
include_directories ("${PROJECT_BINARY_DIR}/include")
if (OPENBLAS_ROOT)
	include_directories ("${OPENBLAS_ROOT}/include")
	link_directories ("${OPENBLAS_ROOT}/lib")
	set (BLAS "openblas")
else ()
	set (BLAS "blas")
endif ()
if (HDF5_ROOT)
	include_directories ("${HDF5_ROOT}/include")
	link_directories ("${HDF5_ROOT}/lib")
	set (CMAKE_REQUIRED_INCLUDES ${HDF5_ROOT}/include)
endif()


##
#   Set up what is to be built
##
add_library (scrappie_objects OBJECT src/decode.c src/event_detection.c src/layers.c src/networks.c src/nnfeatures.c src/scrappie_common.c src/scrappie_matrix.c src/scrappie_seq_helpers.c src/util.c src/homopolymer.c)
set_property(TARGET scrappie_objects PROPERTY POSITION_INDEPENDENT_CODE 1)
add_library (scrappie_static STATIC $<TARGET_OBJECTS:scrappie_objects>)
set_target_properties(scrappie_static PROPERTIES OUTPUT_NAME scrappie CLEAN_DIRECT_OUTPUT 1)
add_executable (test_interface src/test_interface.c)
add_executable (scrappie src/scrappie.c src/scrappie_raw.c src/scrappie_events.c src/scrappie_mappy.c src/scrappie_seqmappy.c src/scrappie_squiggle.c src/scrappie_subcommands.c src/scrappie_help.c src/fast5_interface.c src/scrappie_event_table.c)

if (BUILD_SHARED_LIB)
	if (APPLE)
		message (SEND_ERROR "Building shared library on OSX not yet supported")
	endif (APPLE)
	add_library (scrappie_shared SHARED $<TARGET_OBJECTS:scrappie_objects>)
	set_target_properties(scrappie_shared PROPERTIES OUTPUT_NAME scrappie CLEAN_DIRECT_OUTPUT 1)
	install (TARGETS scrappie_shared LIBRARY DESTINATION lib)
endif (BUILD_SHARED_LIB)

#if ((CMAKE_BUILD_VERSION strequal "Chaos") AND (not defined CHAOSMONKEY))
#    set(CHAOSMONEY 0.1)
#endif ((CMAKE_BUILD_VERSION strequal "Chaos") AND (not defined CHAOSMONKEY))
if (NOT DEFINED CHAOSMONKEY)
    set(CHAOSMONKEY 0.1)
endif ()


##
#  Check whether compiler supports openmp.
##
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -Wall -Wno-unused-function -fstack-protector-all -fgnu89-inline -O3 -march=native -std=c99 -DUSE_SSE2 -D__USE_MISC -D_POSIX_SOURCE -DNDEBUG")
set (CMAKE_C_FLAGS_CHAOS "${CMAKE_C_FLAGS} -Wall -Wno-unused-function -fstack-protector-all -fgnu89-inline -g -march=native -std=c99 -DUSE_SSE2 -D__USE_MISC -D_POSIX_SOURCE -DNDEBUG -DCHAOSMONKEY=${CHAOSMONKEY}")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -Werror -Wall -Wno-cpp -DABORT_ON_NULL -Wno-unused-function -fstack-protector-all -fgnu89-inline -g -march=native -std=c99 -DUSE_SSE2 -D__USE_MISC -D_POSIX_SOURCE")
# Check for OpenMP support in compiler
include (CheckCCompilerFlag)
check_c_compiler_flag ("-fopenmp" HAS_OPENMP)
if (HAS_OPENMP)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fopenmp")
    set (USE_THREADS "--threads" "1")
endif (HAS_OPENMP)


# Find right hdf5 file
include (CheckIncludeFile)
check_include_file ("hdf5.h" HDF5_STANDARD)
if (HDF5_STANDARD)
	set (HDF5 "hdf5")
else (HDF5_STANDARD)
	check_include_file ("hdf5/serial/hdf5.h" HDF5_SERIAL)
	if (HDF5_SERIAL)
		set (HDF5 "hdf5_serial")
        #target_include_directories (scrappie_objects PUBLIC "/usr/include/hdf5/serial")
		include_directories ("/usr/include/hdf5/serial")
        #target_include_directories (scrappie PUBLIC "/usr/include/hdf5/serial")
	endif (HDF5_SERIAL)
endif (HDF5_STANDARD)

target_link_libraries (scrappie scrappie_static ${BLAS} ${HDF5} m)
if (APPLE)
	target_link_libraries (scrappie argp)
endif (APPLE)

install (TARGETS scrappie scrappie_static RUNTIME DESTINATION bin ARCHIVE DESTINATION lib)


enable_testing()
add_executable(scrappie_unittest src/test/scrappie_test_runner.c src/test/test_map_to_sequence.c src/test/test_scrappie_util.c src/test/scrappie_util.c src/test/test_scrappie_convolution.c src/test/test_skeleton.c src/test/test_scrappie_decoding.c src/test/test_scrappie_elu.c src/test/test_scrappie_event_detection.c src/test/test_scrappie_matrix.c src/test/test_scrappie_signal.c src/test/test_scrappie_squiggle.c src/test/test_util.c)
target_include_directories(scrappie_unittest PUBLIC "src/test" "src")
target_link_libraries(scrappie_unittest scrappie_static ${BLAS} ${HDF5} m cunit)

set (READSDIR ${PROJECT_SOURCE_DIR}/reads)
set (TESTREAD "MINICOL228_20161012_FNFAB42578_MN17976_mux_scan_HG_52221_ch271_read66_strand")
set (ENV{OPENBLAS_NUM_THREADS} 1)

add_test(NAME unittest WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src/test/ COMMAND scrappie_unittest)
add_test(test_events_call scrappie events ${USE_THREADS} ${READSDIR})
add_test(test_raw_call scrappie raw --model raw_r94 ${USE_THREADS} ${READSDIR})
add_test(test_rawrgrgr_r94_call scrappie raw --model rgrgr_r94 ${USE_THREADS} ${READSDIR})
add_test(test_rawrgrgr_r941_call scrappie raw --model rgrgr_r941 ${USE_THREADS} ${READSDIR})
add_test(test_rawrgrgr_r10_call scrappie raw --model rgrgr_r10 ${USE_THREADS} ${READSDIR})
add_test(test_rawrnnrf_r94_call scrappie raw --model rnnrf_r94 ${USE_THREADS} ${READSDIR})
add_test(test_event_table scrappie event_table ${READSDIR}/${TESTREAD}.fast5)
add_test(test_mappy scrappie mappy ${READSDIR}/${TESTREAD}.fa ${READSDIR}/${TESTREAD}.fast5)
add_test(test_seqmappy scrappie seqmappy ${READSDIR}/${TESTREAD}.fa ${READSDIR}/${TESTREAD}.fast5)
add_test(test_squiggle_r94 scrappie squiggle --model squiggle_r94 ${READSDIR}/test_squiggles.fa)
add_test(test_squiggle_r10 scrappie squiggle --model squiggle_r10 ${READSDIR}/test_squiggles.fa)
add_test(test_licence scrappie licence)
add_test(test_licence scrappie license)
add_test(test_help scrappie help)
add_test(test_help_events scrappie help events)
add_test(test_help_event_table scrappie help event_table)
add_test(test_help_raw scrappie help raw)
add_test(test_help_squiggle scrappie help squiggle)
add_test(test_version scrappie version)

add_custom_target(test-verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

=== Makefile ===
buildDir ?= build
releaseType ?= Release

.PHONY: all scrappie
all: scrappie
scrappie: ${buildDir}/scrappie

${buildDir}:
	mkdir ${buildDir}

.PHONY: test
test: ${buildDir}/scrappie
	cd ${buildDir} && \
	make test

.PHONY: clean
clean:
	rm -rf ${buildDir}

${buildDir}/scrappie: ${buildDir}
	cd ${buildDir} && \
	cmake .. -DCMAKE_BUILD_TYPE=${releaseType} && \
	make

=== docker/Makefile ===

centos_images := $(addprefix centos/, centos_7_0_1406 centos_7_1_1503 centos_7_2_1511 centos_7_3_1611 centos_7_4_1708)
#  Debian Wheezy not supported due to cmake being too old
debian_images := $(addprefix debian/, jessie stretch)
opensuse_images := $(addprefix opensuse/, opensuse_42_3 opensuse_42_2)
ubuntu_images := $(addprefix ubuntu/, ubuntu_14_04 ubuntu_16_04 ubuntu_17_10 ubuntu_18_04)

.PHONY:all
all: centos debian opensuse ubuntu


.PHONY:centos
centos: $(addsuffix /docker.log, ${centos_images})

.PHONY:debian
debian: $(addsuffix /docker.log, ${debian_images})

.PHONY:opensuse
opensuse: $(addsuffix /docker.log, ${opensuse_images})

.PHONY:ubuntu
ubuntu: $(addsuffix /docker.log, ${ubuntu_images})


%/docker.log : %/Dockerfile
	docker build --tag scrappie:$(notdir $(patsubst %/, %, $(dir $@))) $(patsubst %/, %, $(dir $@)) > $@.tmp && mv $@.tmp $@

=== python/Makefile ===
.PHONY: install clean sdist test_sdist

venv: venv/bin/activate
IN_VENV=. ./venv/bin/activate

venv/bin/activate:
	test -d venv || virtualenv venv --python=python3
	${IN_VENV} && pip install pip --upgrade

install: clean venv
	${IN_VENV} && pip install -r requirements.txt && python setup.py install

sdist: clean venv
	cp -r ../src src
	python setup.py sdist

test_sdist: sdist
	mkdir -p test_sdist
	cd test_sdist && tar -xzvf ../dist/scrappie-*.tar.gz
	${IN_VENV} && cd test_sdist/scrappie-* && python setup.py install && python -c "from scrappy import *; import numpy as np; print(basecall_raw(np.random.normal(10,4,1000)))"

wheels:
	cd .. && docker run -v `pwd`:/io ontresearch/manylinux1_x86_64_openblas /io/python/build-wheels.sh

clean:
	rm -rf lib venv build dist *.egg-info src test_sdist wheelhouse

=== python/requirements.txt ===
cffi>=1.0.0
h5py
numpy

=== src/test/Makefile ===
INCLUDE=-I..
LIBRARY=-lblas -lm
CFLAGS=-std=c11 -O3 -march=native

.PHONY: all
all: read_crp write_random_crp

read_crp: read_crp.o scrappie_util.o scrappie_matrix.o
	${CC} -o $@ $^ ${LIBRARY}

write_random_crp: write_random_crp.o scrappie_util.o scrappie_matrix.o
	${CC} -o $@ $^ ${LIBRARY}

.PHONY: scrappie_matrix.o
scrappie_matrix.o:../scrappie_matrix.o

%.o:%.c
	${CC} ${CFLAGS} ${INCLUDE} -c $<

.PHONY: clean
clean:
	rm -f read_crp.o scrappie_util.o scrappie_matrix.o write_random_crp.o

=== debian/changelog ===
scrappie (1.4.2-9) unstable; urgency=medium

  * Team Upload.
  * Remove myself from uploaders
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Add patch to bump minimum cmake version (Closes: #1113489)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 26 Sep 2025 17:45:52 +0530

scrappie (1.4.2-8) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Standards-Version: 4.6.0 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 01 Oct 2021 16:58:40 +0200

scrappie (1.4.2-7) unstable; urgency=medium

  * Skip one assertion test on ppc64el

 -- Nilesh Patra <nilesh@debian.org>  Sun, 04 Apr 2021 00:40:23 +0530

scrappie (1.4.2-6) unstable; urgency=medium

  * Allow build-time test to fail on ppc64el
  * Add Restriction on allow-stderr

 -- Nilesh Patra <nilesh@debian.org>  Sat, 03 Apr 2021 15:12:19 +0530

scrappie (1.4.2-5) unstable; urgency=medium

  * Team upload.
  * Skip flaky test for armhf
    Closes: #986307

 -- Andreas Tille <tille@debian.org>  Sat, 03 Apr 2021 07:47:34 +0200

scrappie (1.4.2-4) unstable; urgency=medium

  [ Nilesh Patra ]
  * Remove useless test erroneously copied
  * Add myself to uploaders
  * Attempt using simde to compile across more arches
   (Closes: #976479)
  * Add libsimde-dev to build deps
  * Attempt enabling simde-dispatch
  * Add Built-Using as documented in SIMDe wiki, and policy
  * Add override for lintian complaint
    for binaries generated with simde flags

  [ Michael R. Crusoe ]
  * ignore the root Makefile, use cmake

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 09 Dec 2020 00:42:25 +0530

scrappie (1.4.2-3) unstable; urgency=medium

  * Team upload.
  * Add autopkgtest
  * Add manpage

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 25 Oct 2020 20:01:22 +0530

scrappie (1.4.2-2) unstable; urgency=medium

  * Team upload.
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Thu, 06 Aug 2020 17:24:58 +0200

scrappie (1.4.2-1) unstable; urgency=medium

  * Initial release (Closes: #962966)

 -- Steffen Moeller <moeller@debian.org>  Tue, 16 Jun 2020 01:39:12 +0200

=== debian/control ===
Source: scrappie
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper-compat (= 13),
               libcunit1-dev,
               libhdf5-dev,
               libopenblas-dev,
               cmake,
               libsimde-dev
Standards-Version: 4.7.2
Homepage: https://github.com/nanoporetech/scrappie
Vcs-Browser: https://salsa.debian.org/med-team/scrappie
Vcs-Git: https://salsa.debian.org/med-team/scrappie.git
Rules-Requires-Root: no

Package: scrappie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
# Since this package has a MPL-2.0 license, adding Built-Using field
Built-Using: ${simde:Built-Using}
Description: basecaller for Nanopore sequencer
 The Nanopore is a device for DNA/RNA sequencing that does
 not require an amplification of the material. The polynucleotides
 are threaded through a pore and while these pass through,
 the change in the electrostatic potential allows one to
 identify ("call") the actual base that resides in the pore.
 Scrappie goes a step further and also attempts to describe
 modifications to the nucleic acid.

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, python3
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%scrappie-$1.tar.gz%" \
   https://github.com/nanoporetech/scrappie/tags (?:.*?/)release-(\d[\d.]*)\.tar\.gz
